package com.jeequan.jeepay.thirdparty.channel.lklspay.payway;

import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.jeequan.jeepay.core.entity.PayOrder;
import com.jeequan.jeepay.core.exception.BizException;
import com.jeequan.jeepay.core.model.context.MchAppConfigContext;
import com.jeequan.jeepay.core.model.rqrs.AbstractRS;
import com.jeequan.jeepay.core.model.rqrs.msg.ChannelRetMsg;
import com.jeequan.jeepay.core.model.rqrs.payorder.UnifiedOrderRQ;
import com.jeequan.jeepay.core.model.rqrs.payorder.payway.AliBarOrderRQ;
import com.jeequan.jeepay.core.model.rqrs.payorder.payway.AliBarOrderRS;
import com.jeequan.jeepay.thirdparty.channel.lklspay.LklspayKit;
import com.jeequan.jeepay.thirdparty.channel.lklspay.LklspayPaymentService;
import com.jeequan.jeepay.thirdparty.channel.lklspay.model.LklPayMethod;
import com.jeequan.jeepay.thirdparty.util.ApiResBuilder;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;


/**
 * 拉卡拉 支付宝 条码支付
 *
 * @author xiaoyu
 *
 * @date 2022/7/8 11:24
 */
@Service("lklspayPaymentByAliBarService")
public class AliBar extends LklspayPaymentService {

    @Override
    public String preCheck(UnifiedOrderRQ rq, PayOrder payOrder) {
        AliBarOrderRQ bizRQ = (AliBarOrderRQ) rq;
        if(StringUtils.isEmpty(bizRQ.getAuthCode())){
            throw new BizException("用户支付条码[authCode]不可为空");
        }
        this.preCheckAli(bizRQ);
        return null;
    }

    @Override
    public AbstractRS pay(UnifiedOrderRQ rq, PayOrder payOrder, MchAppConfigContext mchAppConfigContext){
        AliBarOrderRQ bizRQ = (AliBarOrderRQ) rq;
        AliBarOrderRS res = ApiResBuilder.buildSuccess(AliBarOrderRS.class);
        ChannelRetMsg channelRetMsg = new ChannelRetMsg();
        JSONObject bizContent = new JSONObject();
        // 默认支付参数
        LklspayKit.setPayParams(mchAppConfigContext, bizContent,payOrder.getClientIp());
        bizContent.put("out_trade_no",payOrder.getPayOrderId());
        bizContent.put("auth_code",bizRQ.getAuthCode());
        bizContent.put("total_amount",payOrder.getFindAmt());
        bizContent.put("subject",payOrder.getSubject());
        bizContent.put("notify_url",getNotifyUrl());
        bizContent.put("settle_type","0");
        bizContent.put("remark",payOrder.getBuyerRemark());
        bizContent.put("scan_type",bizRQ.getScanType());
        JSONObject acc_busi_fields = new JSONObject();
        Integer hbFqNum = bizRQ.getHbFqNum();
        if(hbFqNum != null){
            JSONObject extend_params = new JSONObject();
            extend_params.put("hb_fq_num",hbFqNum);
            extend_params.put("hb_fq_seller_percent",0);
            acc_busi_fields.put("extend_params",extend_params);
        }
        Integer limitPay = bizRQ.getLimitPay();
        if(limitPay != null && limitPay == 1){
            acc_busi_fields.put("disable_pay_channels","credit_group");
        }
        String expiredTime = DateUtil.formatBetween(DateUtil.between(payOrder.getCreatedAt(), payOrder.getExpiredTime(), DateUnit.MINUTE)).replace("毫秒", "");
        acc_busi_fields.put("timeout_express",expiredTime);
        bizContent.put("acc_busi_fields",acc_busi_fields);
        JSONObject response = LklspayKit.payRequest(LklPayMethod.Api.TRANS_MICROPAY, mchAppConfigContext.getMchApplyment(), bizContent);
        this.initResult(response,channelRetMsg);
        res.setChannelRetMsg(channelRetMsg);
        return res;
    }
}
